// By Shock (BL_ID 636)
// With borrowed code from Tool_Duplicator

// Color configuration - see bottom of script.

function determineNearestColor(%color) {
	for (%i = 0; %i < 64; %i++) {
		%colori = getColorIDTable(%i);
		%dist = vectorDist(%colori, %color);
		if (%dist < %best || %best $= "") {
			%best = %dist;
			
			%match = %i;
		}
	}
	
	return %match;
}

function fxDTSBrick::wrenchHighlightDone(%obj) {
	%obj.wrenchHighlightSchedule = "";
	%obj.setColor(%obj.oldColorID);
	%obj.setColorFx(%obj.oldColorFxID);
	%obj.oldColorID = "";
	%obj.oldColorFxID = "";
	
	if (%obj.getDatablock().specialBrickType $= "VehicleSpawn") // vehicle coloring fix
		%obj.colorVehicle();
}

function fxDTSBrick::wrenchHighlight(%obj, %mode) {
	if (%obj.wrenchHighlightSchedule $= "") {
		%obj.oldColorID = %obj.getColorID();
		%obj.oldColorFxID = %obj.getColorFxID();
		
		if (%mode == 0) {
			%obj.setColor($WrenchHighlight::ColorIDStart);
		} else {
			%obj.setColor($WrenchHighlight::ColorIDFinished);
		}
		
		%obj.setColorFx(3);
		
		%obj.wrenchHighlightSchedule = %obj.schedule(500, "wrenchHighlightDone");
	} else {
		cancel(%obj.wrenchHighlightSchedule);
		
		%obj.setColor($WrenchHighlight::ColorIDFinished);
		
		%obj.wrenchHighlightSchedule = %obj.schedule(500, "wrenchHighlightDone");
	}
}

package wrench_Highlight { 
	function fxDTSBrick::sendWrenchData(%obj, %data) { // on wrench bricks
		%obj.wrenchHighlight(0);
		
		return parent::sendWrenchData(%obj, %data);
	}
	
	function fxDTSBrick::sendWrenchSoundData(%obj, %data) { // on wrench music bricks
		%obj.wrenchHighlight(0);
		
		return parent::sendWrenchSoundData(%obj, %data);
	}
	
	function fxDTSBrick::sendWrenchVehicleSpawnData(%obj, %data) { // on wrench vehicle spawns
		%obj.wrenchHighlight(0);
		
		return parent::sendWrenchVehicleSpawnData(%obj, %data);
	}
	
	function serverCmdSetWrenchData(%client, %data) { // finish wrenching (Send>>)
		%client.wrenchBrick.wrenchHighlight(1);
		
		return parent::serverCmdSetWrenchData(%client, %data);
	}
	
	function serverCmdClearEvents(%obj) { // from event menu apply
		%obj.wrenchBrick.wrenchHighlight(1);
		
		return parent::serverCmdClearEvents(%obj);
	}
};

activatePackage(wrench_Highlight);

$WrenchHighlight::ColorIDStart = determineNearestColor("1 1 0 1"); // If someone wishes to override the colors used, do so here
$WrenchHighlight::ColorIDFinished = determineNearestColor("0 1 0 1");